import 'dart:collection';
import 'dart:convert';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../webview_tracking/webview_tracking.dart';
import 'compression.dart';
import 'element_tree.dart';
import 'render_object_extension.dart';
import 'widgets_binding.dart';


RenderView a234() {
  return a180.a207!.renderView;
}


Future<String> a235({
  required String a503,
  required double a504,
}) async {
  final a338 = _a236();

  final a339 = await a338.a21(
    a435: a504,
    
    a436: null,
    a437: a503,
  );

  
  
  a339[0]['style']['bmp'] =
      'com_contentsquare_rootViewBitmapPlaceholder';

  return json.encode(a339);
}


a142 _a236() {
  final a340 = a234();

  final a341 = a196();

  final a342 = _a240(
    a509: a340,
    a510: a341,
  );

  
  
  return a342!;
}


class a142 {
  
  a142({
    required this.a66,
    required this.a65,
    required this.a64,
    required this.a63,
    required this.a62,
  }) : assert(
          a66.a226 == a65,
          'The global frame of the render object must match the global frame of the node',
        );

  
  final RenderObject a66;

  
  final Rect a65;

  
  final String a64;

  
  final Widget a63;

  
  final UnmodifiableListView<a142> a62;

  
  String get a4 => '${a63.runtimeType}';

  
  Future<UnmodifiableListView<Map<String, dynamic>>> a21({
    required double a435,
    required Rect? a436,
    required String a437,
  }) async {
    assert(
      () {
        final a343 = a66 == a234();

        return (a343 && a436 == null) ||
            (!a343 && a436 != null);
      }(),
      'The parent global frame must be null if and only if this is the root node',
    );

    Future<UnmodifiableListView<Map<String, dynamic>>>
        a237() async {
      return UnmodifiableListView([
        for (final a344 in a62)
          ...await a344.a21(
            a435: a435,
            a436: a65,
            a437: a437,
          )
      ]);
    }

    
    
    
    final a345 = a239(
      a507: a66,
      a508: a436,
    );
    if (!a345) {
      return a237();
    }

    /// A function which executes:
    ///   - [callback] if [renderObject] is associated to a WebView
    ///   - [orElse] otherwise
    T a238<T>(
      T Function(a136 webViewTrackerRenderObject)
          a505, {
      required T Function() a506,
    }) {
      final a346 = this.a66;

      if (a346 is a136) {
        return a505(a346);
      } else {
        return a506();
      }
    }

    return UnmodifiableListView([
      {
        'id': a4,
        'metadata': {
          'class_name': a4,
          
          
          'fullpath': a437 + a193(a64),
        },

        /// "recordingId" should only be mandatory for session replay
        /// On the iOS SDK, the structure is used for both: snapshoting and session replay features
        /// so it ends up mandatory for the screengraph passed down to the ExternalBridgeInterface.takeSnapshot completion
        /// For this reason, we set temporarily a 'recordingId' value based on the widget's runtimeType.
        /// TODO: This will need to be checked and discussed when implementing session replay related features
        'recordingId': a4,
        'style': {
          'height': a65.height * a435,
          'width': a65.width * a435,
          'x': a65.left * a435,
          'y': a65.top * a435,
          'visibility': true,
        },
        
        
        'format': a238((_) => 2, a506: () => 1),
        'children': await a238(
          (webViewTrackerRenderObject) async => [
            await webViewTrackerRenderObject.a73(),
          ],
          a506: () => a237(),
        ),
      },
    ]);
  }
}


bool a239({
  required RenderObject a507,
  required Rect? a508,
}) {
  final a347 = a507.a226 != null &&
      a508 != a507.a226;

  final a348 =
      a507 is a136;

  return a347 || a348;
}


a142? _a240({
  required RenderObject a509,
  required a125 a510,
}) {
  assert(
    a510.a111 == a509,
    '	_getPaintedRenderObjectNode was called with a [ElementNode] in which the '
    'renderObject does not match the given [paintedRenderObject]',
  );

  final a349 = a509.a227;
  final a350 = a509.a226;

  
  
  
  
  
  if (a349 == null || a350 == null) {
    return null;
  }

  final a351 = <a142>[];
  
  
  final a352 = LayerHandle<ContainerLayer>();
  a352.layer = ContainerLayer();

  final a353 = _a143(
    a352.layer!,
    a349,
  );

  
  
  
  a509.paint(a353, Offset.zero);

  
  a352.layer = null;

  
  final a354 = a353.a3;
  for (final a355 in a354) {
    final a356 = _a241(
      a513: a355,
      a514: a510,
    );

    
    
    
    
    
    
    
    
    if (a356 != null) {
      final a357 = _a240(
        a509: a355,
        a510: a356,
      );

      if (a357 != null) {
        a351.add(a357);
      }
    }
  }

  
  
  
  
  
  a509.markNeedsPaint();

  return a142(
    a66: a509,
    a65: a350,
    a63: a510.a112,
    a64: a510.a110,
    a62: UnmodifiableListView(a351),
  );
}


class _a143 extends PaintingContext {
  _a143(
    ContainerLayer a511,
    Rect a512, {
    this.a61,
  }) : super(a511, a512);

  
  UnmodifiableListView<RenderObject> get a3 =>
      UnmodifiableListView<RenderObject>(_a358);

  
  final List<RenderObject> _a358 = <RenderObject>[];

  /// This is what is called by a [renderObject] to paint a child.
  @override
  void paintChild(RenderObject child, Offset offset) {
    _a358.add(child);
    a61?.call(child);

    
  }

  
  final void Function(RenderObject child)? a61;

  /// Some render object use [_a143.pushLayer] to paint their
  /// children. This calls [createChildContext] to create a new context on which
  /// the render object will paint its child.
  /// Therefore we need to also return an [_a143] which will
  /// report to this [_a143] the children that tried to be
  /// painted.
  @override
  _a143 createChildContext(
    ContainerLayer childLayer,
    Rect bounds,
  ) {
    return _a143(
      childLayer,
      bounds,
      a61: _a358.add,
    );
  }
}


a125? _a241({
  required RenderObject a513,
  required a125 a514,
}) {
  final a359 = a514;

  
  
  final a360 = List.of([a359]);
  while (a360.isNotEmpty) {
    final a361 = a360.removeAt(0);
    if (a361.a111 == a513) {
      return a361;
    }

    a360.addAll(a361.a109);
  }

  return null;
}
